#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    while (q--) {
        solve();
    }
}

ll get(string& r) {
    vector<ll> p = {2, 3, 5, 7};
    ll ans = 0;
    for (int i = 1; i < r.size(); i++) {
        ans += i * 4;
    }
    ll id1 = (int)r.size();
    ll id2 = (int)r.size();
    for (int i = 0; i < r.size(); i++) {
        if (r[i] == '0' && id1 == (int)r.size()) {
            id1 = i;
        }
        if (r[i] > '1' && id2 == r.size()) {
            id2 = i;
        }
    }
    for (int i = 0; i < r.size(); i++) {
        if (i < id2) {
            continue;
        }
        if (i >= id1 && id1 < id2) {
            continue;
        }
        for (auto j : p) {
            if (id2 != i) {
                ans++;
            } else {
                string tc;
                tc.resize((int)r.size(), '1');
                tc[i] = j + '0';
                if (tc <= r) {
                    ans++;
                }
            }
        }
    }
    return ans;
}

void solve() {
    string l, r;
    cin >> l >> r;
    ll ans = get(r) - get(l);
    vector<ll> used(10);
    for (auto i : l) {
        used[i - '0']++;
    }
    vector<ll> s = {0, 4, 6, 8, 9};
    bool f = true;
    for (auto i : s) {
        if (used[i] > 0) {
            f = false;
        }
    }
    vector<ll> p = {2, 3, 5, 7};
    for (auto i : p) {
        if (used[i] > 1) {
            f = false;
        }
    }
    if (used[1] == l.size()) {
        f = false;
    }
    if (f) {
        ans++;
    }
    cout << ans;
}