#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    while (q--) {
        solve();
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    ll all = 1;
    for (int i = 1; i <= k; i++) {
        all *= (1ll << i);
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(all));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int mask = 0; mask < all; mask++) {
            vector<vector<ll>> cur(k, vector<ll>(k));
            ll col = 0, cnt = 0;
            for (int j = 0; j < k; j++) {
                for (int t = 0; t <= j; t++) {
                    cur[j][t] = (mask >> cnt) & 1;
                    cnt++;
                    col += cur[j][t];
                }
            }
            if (col != b[i - 1]) {
                continue;
            }
            ll nw = max(0, k - i);
            cnt = 0;
            for (int j = 0; j < nw; j++) {
                for (int t = 0; t < k; t++) {
                    cnt += cur[j][t];
                }
            }
            if (cnt > 0) {
                continue;
            }
            ll mask2 = 0;
            cnt = 0;
            for (int j = 1; j < k; j++) {
                for (int t = 0; t < j; t++) {
                    if (cur[j][t] == 1) {
                        mask2 += (1ll << cnt);
                    }
                    cnt++;
                }
            }
            ll mask3 = 0;
            cnt = 0;
            for (int j = 0; j < k - 1; j++) {
                for (int t = 0; t <= j; t++) {
                    if (cur[j][t]) {
                        mask3 += (1ll << cnt);
                    }
                    cnt++;
                }
            }
            dp[i][mask2] += dp[i - 1][mask3];
            dp[i][mask2] %= MOD;
        }
    }
    ll ans = 0;
    for (int i = 0; i < all; i++) {
        ans += dp[n][i];
        ans %= MOD;
    }
    cout << ans;
}
