#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    while (q--) {
        solve();
    }
}

struct st {
    int mask2 = 0, mask3 = 0;
};
int mask2 = 0, mask3 = 0;
vector<st> a;
void get(int i, int j, int cnt, int k, int f, int len, int z, int cnt1, int cnt2) {
    if (cnt == len) {
        a.push_back({mask2, mask3});
        return;
    }
    int x = i, y = j;
    if (i == j) {
        x++;
        y = 0;
    } else {
        y++;
    }
    if (k != 0 && cnt >= f) {
        if (1 <= i && j < i) {
            mask2 += (1 << cnt1);
            cnt1++;
        }
        if (i < z - 1) {
            mask3 += (1 << cnt2);
            cnt2++;
        }
        get(x, y, cnt + 1, k - 1, f, len, z, cnt1, cnt2);
        if (1 <= i && j < i) {
            cnt1--;
            mask2 -= (1 << cnt1);
        }
        if (i < z - 1) {
            cnt2--;
            mask3 -= (1 << cnt2);
        }
    }
    if (len - cnt - 1 >= k) {
        if (1 <= i && j < i) {
            cnt1++;
        }
        if (i < z - 1) {
            cnt2++;
        }
        get(x, y, cnt + 1, k, f, len, z, cnt1, cnt2);
    }
}

int dp[201][(1ll << 21)];

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int aint = 1;
    for (int i = 1; i <= k; i++) {
        aint *= (1 << i);
    }
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        a.clear();
        int fl = max(0, k - i);
        int sm = fl * (fl + 1) / 2;
        get(0, 0, 0, b[i - 1], sm, k * (k + 1) / 2, k, 0, 0);
        for (auto [mask2, mask3] : a) {
            dp[i][mask2] += dp[i - 1][mask3];
            dp[i][mask2] %= MOD;
        }
    }
    int ans = 0;
    for (int i = 0; i < aint; i++) {
        ans += dp[n][i];
        ans %= MOD;
    }
    cout << ans;
}
