#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    while (q--) {
        solve();
    }
}

int mask = 0;
vector<int> a;
void get(int i, int k, int len, int f) {
    if (i == len) {
        a.push_back(mask);
        return;
    }
    if (k != 0 && i >= f) {
        mask += (1 << i);
        get(i + 1, k - 1, len, f);
        mask -= (1 << i);
    }
    if (len - i - 1 >= k) {
        get(i + 1, k, len, f);
    }
}

int dp[201][(1ll << 21)];

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int aint = 1;
    for (int i = 1; i <= k; i++) {
        aint *= (1 << i);
    }
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        a.clear();
        int fl = max(0, k - i);
        int sm = fl * (fl + 1) / 2;
        get(0, b[i - 1], k * (k + 1) / 2, sm);
        for (auto mask : a) {
            vector<vector<int>> cur(k, vector<int>(k));
            int cnt = 0;
            for (int j = 0; j < k; j++) {
                for (int t = 0; t <= j; t++) {
                    cur[j][t] = (mask >> cnt) & 1;
                    cnt++;
                }
            }
            int mask2 = 0, mask3 = 0;
            int cnt1 = 0, cnt2 = 0;
            for (int j = 0; j < k; j++) {
                for (int t = 0; t <= j; t++) {
                    if (j > 0 && t < j) {
                        if (cur[j][t] == 1) {
                            mask2 += (1 << cnt1);
                        }
                        cnt1++;
                    }
                    if (j < k - 1) {
                        if (cur[j][t] == 1) {
                            mask3 += (1 << cnt2);
                        }
                        cnt2++;
                    }
                }
            }
            dp[i][mask2] += dp[i - 1][mask3];
            dp[i][mask2] %= MOD;
        }
    }
    int ans = 0;
    for (int i = 0; i < aint; i++) {
        ans += dp[n][i];
        ans %= MOD;
    }
    cout << ans;
}
