#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    ll all = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        all += a[i];
    }
    if (k == 2) {
        ll sm = 0, ans = 0;
        for (int i = 0; i < n - 1; i++) {
            sm += a[i];
            ans = max(ans, max(sm, all - sm) - min(sm, all - sm));
        }
        cout << ans;
        return;
    }
    vector<ll> pref = {INF};
    for (int i = 0; i < n; i++) {
        pref.push_back(min(pref.back(), a[i]));
    }
    vector<ll> suf(n + 1);
    suf[n] = INF;
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = min(suf[i + 1], a[i]);
    }
    ll ans = 0;
    for (int l = 0; l < n; l++) {
        ll sm = 0;
        for (int r = l; r < n; r++) {
            sm += a[r];
            if (r - l > n - k) {
                break;
            }
            ans = max(ans, sm - min(pref[l], suf[r + 1]));
        }
    }
    cout << ans;
}