#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}

vector<ll> mn_in_win(vector<ll>& a, ll k) {
    deque<ll> opt;
    vector<ll> ans(a.size());
    for (int i = 0; i < a.size(); i++) {
        while (!opt.empty() && a[opt.back()] > a[i]) {
            opt.pop_back();
        }
        opt.push_back(i);
        while (opt.front() < i - k) {
            opt.pop_front();
        }
        ans[i] = a[opt.front()];
    }
    return ans;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    ll all = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        all += a[i];
    }
    if (k == 2) {
        ll sm = 0, ans = 0;
        for (int i = 0; i < n - 1; i++) {
            sm += a[i];
            ans = max(ans, max(sm, all - sm) - min(sm, all - sm));
        }
        cout << ans;
        return;
    }
    vector<ll> pref = {0};
    for (int i = 0; i < n; i++) {
        pref.push_back(pref.back() + a[i]);
    }
    vector<ll> fr = mn_in_win(pref, n - k + 1);
    vector<ll> p(pref.size());
    p[0] = -INF;
    for (int i = 1; i < pref.size(); i++) {
        p[i] = max(p[i], pref[i] - fr[i]);
    }
    reverse(a.begin(), a.end());
    pref = {0};
    for (int i = 0; i < n; i++) {
        pref.push_back(pref.back() + a[i]);
    }
    vector<ll> sc = mn_in_win(pref, n - k + 1);
    vector<ll> s(pref.size());
    s[0] = -INF;
    for (int i = 1; i < pref.size(); i++) {
        s[i] = max(s[i], pref[i] - sc[i]);
    }
    reverse(s.begin(), s.end());
    reverse(a.begin(), a.end());
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ans = max(ans, p[i] - a[i]);
        ans = max(ans, s[i + 1] - a[i]);
    }
    cout << ans;
}