#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}

void solve() {
    ll n, s;
    cin >> n >> s;
    vector<vector<ll>> a(n);
    vector<vector<vector<vector<bool>>>> dp(n);
    for (int i = 0; i < n; i++) {
        ll m;
        cin >> m;
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
        dp[i].resize(m, vector<vector<bool>>(s + 1, vector<bool>(2)));
    }
    dp[0][0][0][0] = true;
    if (a[0][0] <= s) {
        dp[0][0][a[0][0]][1] = true;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < a[i].size(); j++) {
            for (int k = 0; k <= s; k++) {
                if (j - 1 >= 0 &&
                    dp[i][j - 1][k][0]) {
                    dp[i][j][k][0] = true;
                }
                if (i - 1 >= 0 && dp[i - 1][a[i - 1].size() - 1][k][1]) {
                    dp[i][j][k][0] = true;
                }
                if (j - 1 >= 0 && dp[i][j - 1][k][1]) {
                    dp[i][j][k][1] = true;
                }
                if (j - 1 >= 0 && k - a[i][j] >= 0 && (dp[i][j - 1][k - a[i][j]][0] ||
                    dp[i][j - 1][k - a[i][j]][1])) {
                    dp[i][j][k][1] = true;
                }
                if (i - 1 >= 0 && k - a[i][j] >= 0 && dp[i - 1][a[i - 1].size() - 1][k - a[i][j]][1]) {
                    dp[i][j][k][1] = true;
                }
            }
        }
    }
    if (dp[n - 1][a[n - 1].size() - 1][s][1]) {
        cout << "Yes";
    } else {
        cout << "No";
    }
}