#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}
void solve() {
    int n, s;
    cin >> n >> s;
    int n1 = n;
    vector<int> a, mx, idx, num;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        for (int j = 0; j < m; j++) {
            int x;
            cin >> x;
            num.push_back(j);
            idx.push_back(i);
            mx.push_back(i);
            a.push_back(x);
        }
        mx.pop_back();
        mx.push_back(i + 1);
    }
    n = a.size();
    vector<vector<int>> dp(n + 1, vector<int>(s + 1, -INF));
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= s; j++) {
            if (dp[i - 1][j] >= mx[i - 1]) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j]);
            }
            if (j - a[i - 1] >= 0 && dp[i - 1][j - a[i - 1]] + 1 >= mx[i - 1]) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j - a[i - 1]] + 1);
            }
        }
    }
    if (dp[n][s] < mx[n - 1]) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    int i = n, j = s;
    vector<vector<int>> ans(n1);
    while (j != 0) {
        if (dp[i - 1][j] == dp[i][j]) {
            i--;
            continue;
        }
        ans[idx[i - 1]].push_back(num[i - 1]);
        i--;
        j -= a[i];
    }
    for (auto &x : ans) {
        cout << x.size() << '\n';
        for (auto y : x) {
            cout << y + 1 << ' ';
        }
        cout << '\n';
    }
}
