#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
/*#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif*/
    int q = 1;
    while (q--) {
        solve();
    }
}

vector<vector<bitset<100000> > > dp[100000];

void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<int> > a(n);
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
        dp[i].resize(m, vector<bitset<100000> >(2));
    }
    dp[0][0][0][0] = true;
    if (a[0][0] <= s) {
        dp[0][0][1][a[0][0]] = true;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < a[i].size(); j++) {
            if (j - 1 >= 0) {
                dp[i][j][0] |= dp[i][j - 1][0];
            }
            if (i - 1 >= 0) {
                dp[i][j][0] |= dp[i - 1][a[i - 1].size() - 1][1];
            }
            if (j - 1 >= 0) {
                dp[i][j][1] |= dp[i][j - 1][1];
            }
            if (j - 1 >= 0) {
                dp[i][j][1] |= (dp[i][j - 1][0] << a[i][j]);
                dp[i][j][1] |= (dp[i][j - 1][1] << a[i][j]);
            }
            if (i - 1 >= 0) {
                dp[i][j][1] |= (dp[i - 1][a[i - 1].size() - 1][1] << a[i][j]);
            }
        }
    }

    if (!dp[n - 1][a[n - 1].size() - 1][1][s]) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    vector<vector<int> > ans(n);
    int i = n - 1, j = a[n - 1].size() - 1, k = s, f = 1;
    while (k != 0) {
        if (i == 0 && j == 0) {
            ans[0].push_back(0);
            break;
        }
        if (f == 0) {
            if (j - 1 >= 0 &&
                dp[i][j - 1][0][k]) {
                j--, f = 0;
            } else {
                i--;
                j = a[i].size() - 1;
                f = 1;
            }
        } else {
            if (j - 1 >= 0 && dp[i][j - 1][1][k]) {
                j--;
                f = 1;
            } else if (j - 1 >= 0 && k - a[i][j] >= 0 && dp[i][j - 1][0][k - a[i][j]]) {
                ans[i].push_back(j);
                k -= a[i][j];
                j--;
                f = 0;
            } else if (j - 1 >= 0 && k - a[i][j] >= 0 && dp[i][j - 1][1][k - a[i][j]]) {
                ans[i].push_back(j);
                k -= a[i][j];
                j--;
                f = 1;
            } else {
                ans[i].push_back(j);
                k -= a[i][j];
                i--;
                j = a[i].size() - 1;
                f = 1;
            }
        }
    }
    for (auto &t: ans) {
        reverse(t.begin(), t.end());
        cout << t.size() << '\n';
        for (auto x: t) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }
}
