#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}
vector<vector<vector<bool> > > dp[100000];

void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<int> > a(n);
    bool fl = false;
    ll cnt = 0;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            cnt += a[i][j];
        }
        if (m != 1) {
            fl = true;
        }
        dp[i].resize(m, vector<vector<bool> >(s + 1, vector<bool>(2)));
    }
    if (!fl) {
        if (cnt == s) {
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                cout << 1 << '\n' << 1 << '\n';
            }
        } else {
            cout << "No";
        }
        return;
    }
    dp[0][0][0][0] = true;
    if (a[0][0] <= s) {
        dp[0][0][a[0][0]][1] = true;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < a[i].size(); j++) {
            for (int k = 0; k <= s; k++) {
                if (j - 1 >= 0 &&
                    dp[i][j - 1][k][0]) {
                    dp[i][j][k][0] = true;
                }
                if (i - 1 >= 0 && dp[i - 1][a[i - 1].size() - 1][k][1]) {
                    dp[i][j][k][0] = true;
                }
                if (j - 1 >= 0 && dp[i][j - 1][k][1]) {
                    dp[i][j][k][1] = true;
                }
                if (j - 1 >= 0 && k - a[i][j] >= 0 && (dp[i][j - 1][k - a[i][j]][0] ||
                                                       dp[i][j - 1][k - a[i][j]][1])) {
                    dp[i][j][k][1] = true;
                }
                if (i - 1 >= 0 && k - a[i][j] >= 0 && dp[i - 1][a[i - 1].size() - 1][k - a[i][j]][1]) {
                    dp[i][j][k][1] = true;
                }
            }
        }
    }
    if (!dp[n - 1][a[n - 1].size() - 1][s][1]) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    vector<vector<int>> ans(n);
    int i = n - 1, j = a[n - 1].size() - 1, k = s, f = 1;
    while (k != 0) {
        if (i == 0 && j == 0) {
            ans[0].push_back(0);
            break;
        }
        if (f == 0) {
            if (j - 1 >= 0 &&
                dp[i][j - 1][k][0]) {
                j--, f = 0;
                }
            else {
                i--;
                j = a[i].size() - 1;
                f = 1;
            }
        } else {
            if (j - 1 >= 0 && dp[i][j - 1][k][1]) {
                j--;
                f = 1;
            }
            else if (j - 1 >= 0 && k - a[i][j] >= 0 && dp[i][j - 1][k - a[i][j]][0]) {
                ans[i].push_back(j);
                k -= a[i][j];
                j--;
                f = 0;
            }
            else if (j - 1 >= 0 && k - a[i][j] >= 0 && dp[i][j - 1][k - a[i][j]][1]) {
                ans[i].push_back(j);
                k -= a[i][j];
                j--;
                f = 1;
            } else {
                ans[i].push_back(j);
                k -= a[i][j];
                i--;
                j = a[i].size() - 1;
                f = 1;
            }
        }
    }
    for (auto &t : ans) {
        reverse(t.begin(), t.end());
        cout << t.size() << '\n';
        for (auto x : t) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }
}
