#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}

ll fc(ll x) {
    ll ans = 1;
    for (ll i = 1; i <= x; i++) {
        ans *= i;
        ans %= MOD;
    }
    return ans;
}

ll pw(ll a, ll st) {
    if (st == 0) {
        return 1;
    }
    ll k = pw(a, st / 2);
    if (st % 2 == 0) {
        return k * k % MOD;
    } else {
        return k * k % MOD * a % MOD;
    }
}

ll c(ll n, ll k) {
    return fc(n) * pw(fc(k) * fc(n - k) % MOD, MOD - 2) % MOD;
}

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    if (k == 0) {
        cout << c(n + m - 2, n - 1);
    }
}
