#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}

vector<vector<pair<int, int>>> as;
vector<pair<int, int>> cur = {{0, 0}};
ll n, m;
void get_path(ll x, ll y) {
    if (x == n - 1 && y == m - 1) {
        as.push_back(cur);
        return;
    }
    if (x + 1 != n) {
        cur.emplace_back(x + 1, y);
        get_path(x + 1, y);
        cur.pop_back();
    }
    if (y + 1 != n) {
        cur.emplace_back(x, y + 1);
        get_path(x, y + 1);
        cur.pop_back();
    }
}

void solve() {
    ll k;
    cin >> n >> m >> k;
    vector<pair<ll ,ll>> a;
    for (int i = 0; i < k; i++) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        a.emplace_back(x, y);
    }
    get_path(0, 0);
    ll ans = 0;
    for (auto &i : as) {
        vector<vector<ll>> used(n, vector<ll>(m));
        for (auto [x, y] : i) {
            used[x][y] = 1;
        }
        bool f = true;
        for (auto &j : as) {
            for (auto [x, y] : j) {
                if (used[x][y]) {
                    f = false;
                }
                used[x][y] = 1;
            }
        }
        for (auto [x, y] : a) {
            if (!used[x][y]) {
                f = false;
            }
        }
        if (f) {
            ans++;
        }
    }
    cout << ans;
}
