#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9, MOD = 1e9 + 7;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    while (q--) {
        solve();
    }
}

vector<vector<pair<int, int>>> as;
vector<pair<int, int>> cur = {{0, 0}};
int n, m;
void get_path(int x, int y) {
    if (x == n - 1 && y == m - 1) {
        as.push_back(cur);
        return;
    }
    if (x + 1 != n) {
        cur.emplace_back(x + 1, y);
        get_path(x + 1, y);
        cur.pop_back();
    }
    if (y + 1 != m) {
        cur.emplace_back(x, y + 1);
        get_path(x, y + 1);
        cur.pop_back();
    }
}

void solve() {
    int k;
    cin >> n >> m >> k;
    vector<pair<int ,int>> a;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        a.emplace_back(x, y);
    }
    get_path(0, 0);
    int ans = 0;
    for (int i = 0; i < as.size(); i++) {
        vector<vector<int>> used(n, vector<int>(m));
        for (auto [x, y] : as[i]) {
            used[x][y]++;
        }
        for (int j = i + 1; j < as.size(); j++) {
            bool f = true;
            for (auto [x, y] : as[j]) {
                used[x][y]++;
            }
            for (auto [x, y] : a) {
                if (used[x][y] == 0) {
                    f = false;
                }
            }
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    if (x == 0 && y == 0) {
                        continue;
                    }
                    if (x == n - 1 && y == m - 1) {
                        continue;
                    }
                    if (used[x][y] > 1) {
                        f = false;
                    }
                }
            }
            if (f) {
                ans++;
            }
            for (auto [x, y] : as[j]) {
                used[x][y]--;
            }
        }
    }
    cout << 2 * ans;
}
